package com.dormmom.flutter_vtmap_navigation.factory

import android.app.Activity
import android.content.Context
import android.widget.Toast

import com.viettel.vtmsdk.MapVT
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.StandardMessageCodec
import io.flutter.plugin.platform.PlatformView
import io.flutter.plugin.platform.PlatformViewFactory


class MapViewFactory(private val messenger: BinaryMessenger, private val activity: Activity) : PlatformViewFactory(StandardMessageCodec.INSTANCE) {
    
    override fun create(context: Context?, viewId: Int, args: Any?): PlatformView {
        val params = args as? Map<*, *>
       var accessToken: String  = "";
        if(params != null ) {
               accessToken = (params["access_token"] as? String)!!;//PluginUtilities.getResourceFromContext(context!!, "mapbox_access_token")
            if (accessToken != null && !accessToken.equals("access_token")){
                MapVT.getInstance(context!!, accessToken)
            }else{
                Toast.makeText(context,"access_token is missing", Toast.LENGTH_SHORT).show()
            }
        }else{
            Toast.makeText(context,"access_token is missing", Toast.LENGTH_SHORT).show()
        }
        return FlutterMapViewFactory(context!!, messenger, accessToken, viewId, activity, args)
    }
}